; Robs BB-Kurs 2
; Robert Gerlach 12.2001
;
; Wasser
; ----------------------------------------------
; Ein Wassersimulator. Mit linker Maustaste Wasser und mit
; rechter Land erzeugen. Das Wasser luft am Land runter
; und sammelt sich in Becken. Sieht gut aus und macht Spa ^_^.


Graphics 320,240,16,1
SetBuffer BackBuffer()

Global cursor = LoadImage("cursor.bmp")
MaskImage cursor, 0, 255, 255

Dim feld(320,240)

For x = 1 To 320
For y = 1 To 240
feld(x,y) = 0
Next
Next


Type tropfen
Field x
Field y
End Type

Type sandkorn
Field x
Field y
End Type

;----------------------------------------------------
Repeat
Cls

zeugmalen

wasserbewegen

zeugsetzen

Flip
Until KeyHit(1)
End

;----------------------------------
Function wasserbewegen()
For wasser.tropfen = Each tropfen

If feld(wasser\x, wasser\y + 1) = 0 Then
feld(wasser\x, wasser\y) = 0  ; Alte Stelle auf 0 setzen
wasser\y = wasser\y + 1
feld(wasser\x, wasser\y) = 2  ; Neue auf 1, da da jetzt ein Tropfen ist...
Else

If feld(wasser\x + 1, wasser\y) = 0 Then ; Wenn rechts frei st, geht er vielleicht (wegen Rnd()) nach rechts
If feld(wasser\x+2, wasser\y) = 0 Then  ; Wenn auch noch das nchste frei ist...
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x + Rnd(1,2)
feld(wasser\x, wasser\y) = 2
Else
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x + Rnd(0,1)
feld(wasser\x, wasser\y) = 2
EndIf



EndIf

If feld(wasser\x-1, wasser\y) = 0 Then ; Wenn links frei ist
If feld(wasser\x-2, wasser\y) = 0 Then
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x - Rnd(1,2)
feld(wasser\x, wasser\y) = 2
Else
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x - Rnd(0,1)
feld(wasser\x, wasser\y) = 2
EndIf


EndIf
If feld(wasser\x - 1, wasser\y + 1) = 0 Then ; Wenn es links runter geht:
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x - 1
wasser\y = wasser\y + 1
feld(wasser\x, wasser\y) = 2
EndIf

If feld(wasser\x + 1, wasser\y + 1) = 0 Then ; Wenn es rechts runter geht:
feld(wasser\x, wasser\y) = 0
wasser\x = wasser\x + 1
wasser\y = wasser\y + 1
feld(wasser\x, wasser\y) = 2
EndIf

EndIf

If wasser\y >= 238 Then Delete wasser.tropfen

Next
 
End Function

;-----------------------------


Function zeugmalen()
LockBuffer BackBuffer()
For wasser.tropfen = Each tropfen
WritePixelFast wasser\x, wasser\y, rgb(10, Rnd(0,100), 155)
Next

For erde.sandkorn = Each sandkorn
WritePixelFast erde\x, erde\y, rgb(120,55,0)
Next

UnlockBuffer BackBuffer()
DrawImage cursor, MouseX(), MouseY()
End Function

;--------------------------------------
Function zeugsetzen()
; Wasser erzeugen
If MouseDown(1) Then
wasser.tropfen = New tropfen
wasser\x = MouseX()
wasser\y = MouseY()
EndIf

; Erde malen
If MouseDown(2) Then
For x = -1 To 1
For y = -1 To 1
If feld(x+MouseX(),y+MouseY()) <> 2 Then
erde.sandkorn = New sandkorn
erde\x = MouseX() + x
erde\y = MouseY() + y
feld(x+MouseX(), y+MouseY()) = 1
EndIf
Next
Next
EndIf


End Function


;-----------------------------------
Function rgb(rot,gruen,blau)
	Return blau Or (gruen Shl 8) Or (rot Shl 16)
End Function

































