; Robs BB-Kurs 2
; Robert Gerlach 12.2001
;
; Sterne
; ----------------------------------------------
; Ein Sternenfeld. Realistischere Version.
; Original von Matty B, verbessert (WritePixel etc.) und kommentiert von mir.





Global anzahl=5000   ; Anzahl der Sterne
Global speed=2       ; Geschwindigkeit 
Global x_screen=640  ; Auflsung
Global y_screen=480  ;




Dim stern_x(anzahl),stern_y(anzahl),stern_z(anzahl)


Graphics x_screen,y_screen, 16, 1
SetBuffer BackBuffer()


star_init()

Repeat
Cls
star_update()
Flip
Until KeyHit(1)
End


; Den Sternen eine Position zuweisen
Function star_init()

; Alle Sterne durchgehn
For i=0 To anzahl
stern_x(i) = Rnd( -(x_screen/2), (x_screen/2)) Shl 8
stern_y(i) = Rnd( -(y_screen/2), (y_screen/2)) Shl 8
stern_z(i) = Rnd(speed,255)
Next 

End Function



;##############################################################
; Die Sterne bewegen
Function star_update()


; Buffer fr WritePixel locken
LockBuffer BackBuffer()


; Alle Sterne durchgehn
For i = 0 To anzahl
stern_z(i) = stern_z(i) - speed

If stern_z(i) <= speed Then stern_z(i) = 255

; Position ausrechnen. Zum Rand hin werden die Sterne schneller.
s_x = (stern_x(i) / stern_z(i)) + (x_screen / 2)
s_y = (stern_y(i) / stern_z(i)) + (y_screen / 2)
farbe = 255 - stern_z(i)


; Pixel schnell und zum Rand hin heller zeichnen.
WritePixel s_x, s_y, farbe Or (farbe Shl 8) Or (farbe Shl 16)


Next

UnlockBuffer BackBuffer()

End Function