; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; Sinus/Cosinus - Beispiel Nr. 4
;----------------------------------------------
; Text auf einer Sinus-Welle bewegen. Einfachere Methode...


; 640x480 bei hchstmglicher Farbtiefe im Vollbildmodus.
Graphics 640, 480, 0, 1
SetBuffer BackBuffer()

; Ein Text. Dieser wird spter in die einzelnen Buchstaben aufgesplittet.
zeug$ = "Heut essen wir den Suppenhahn den gestern wir noch huppen sahn."


; Textlnge ermitteln.
textlaenge = Len(zeug$)


; Fr jeden Buchstabe ein eigener y-Wert und Winkel fr den Sinus.
Dim y#(textlaenge)
Dim winkel#(textlaenge)


; Dem Winkel Werte zuweisen und die Buchstaben gleich positionieren.
For i = 1 To textlaenge
winkel#(i) = 360 - i*(360/textlaenge)
y#(i) = 240  ; Damit es in der Mitte ist.
Next


Repeat
Cls






; Alle Buchstabe durcharbeiten.
For x = 1 To textlaenge


; Die jeweiligen Winkel erhhen und bei 360 wieder zu 0 gehen.
winkel#(x) = winkel#(x) + 1
If winkel#(x) = 360 Then winkel#(x) = 0


; Buchstabe aus String extrahieren
buchstabe$ = Mid(zeug$, x, 1)

y#(x) = y#(x) + Sin(winkel#(x))



; Ein bisschen die Farben verndern...
Color y#(20), y#(10), y#(1)


; Buchstabe ausgeben. +240 damit es in der Mitte ist.
Text x*10, y#(x), buchstabe$








Next




Flip
Until KeyHit(1)
End