; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; Spline
; ----------------------------------------------
; Zeichnet eine Splinekurve die man mit der Maus steuern kann.
;
; Von: TheShadow
;      www.blitzbasic.de
; 
;
; Maussteuerung von mir.






Graphics 640, 480, 16, 2
SetBuffer BackBuffer()



;Beispiel
x1=50:  y1=150
x2=100: y2=100
x3=150: y3=100
x4=200: y4=150


Repeat
Cls


x3 = MouseX()
y3 = MouseY()

SpLine x1,y1, x1,y1, x2,y2, x3,y3
SpLine x1,y1, x2,y2, x3,y3, x4,y4
SPLine x2,y2, x3,y3, x4,y4, x4,y4
Oval x1-5,y1-5,10,10,0
Oval x2-5,y2-5,10,10,0
Oval x3-5,y3-5,10,10,0
Oval x4-5,y4-5,10,10,0
Text 0,0,"SpLine-Demo"


Flip
Until KeyHit(1)
End


;-------------------------------------------------------------------
;Zeichnet eine "CATMULL ROM SLINE". Dabei werden die Start- und
;Endpunkte berhrt. Die Abweichung von der idealen Form ist minimal.
;Ideal zum Verbinden von Koordinatenketten mit einer Linie. Der
;Start- und Endpunkt einer Koordinatenkette mssen doppelt angegeben
;werden.
;
;x1 = Horizontale Ablenkkoordinate 1
;y1 = Vertikale   Ablenkkoordinate 1
;x2 = Horizontale Startkoordinate
;y2 = Vertikale   Startkoordinate
;x3 = Horizontale Endkoordinate
;y3 = Vertikale   Endkoordinate
;x4 = Horizontale Ablenkkoordinate 2
;y4 = Vertikale   Ablenkkoordinate 2
;-------------------------------------------------------------------
Function SpLine(x1,y1,x2,y2,x3,y3,x4,y4)
	For u#=0 To 1.1 Step .1
		u2#=u#*u#
		u3#=u#*u#*u#
		f1#=-0.5*u3# + 1.0*u2# - 0.5*u#
		f2#= 1.5*u3# - 2.5*u2# + 1.0
		f3#=-1.5*u3# + 2.0*u2# + 0.5*u#
		f4#= 0.5*u3# - 0.5*u2#
		x=x1*f1# + x2*f2# + x3*f3# + x4*f4#
		y=y1*f1# + y2*f2# + y3*f3# + y4*f4#
		If u#>0 Then Line ax,ay,x,y
		ax=x
		ay=y
	Next
End Function