; EMail Functions v0.1
; Robert Gerlach 2.2002
; www.robsite.de

Global com 
; In jedem Element wird eine Zeile der Mail gespeichert, so ist es nachher einfacher daraus
; Informationen zu extrahieren. 
Global mailzeilen_anzahl
Dim mailzeilen$(mailzeilen_anzahl) ; Wird bei jeder neuen Mail redimensioniert.









;------------------------------------------------------------
; Testprogramm fr die Functions


server$ = "pop3.deinProvider.de"
user$ = "username"
pass$ = "passwort"


; Verbinden mit und einloggen auf dem Server
login$ = popAccountLogin$(server$, user$, pass$)




If Mid(login$, 1, 3) = "+OK" Then


; Anzahl und Gre der Mails abfragen
statstring$ = popAccountStat$()

; Die Erste Nummer (Anzahl der Mails) aus dem String extrahieren.
anzahl = zahlausstring(statstring$, 1)

; Wenn welche draufsind, ausgeben.
If anzahl > 0 Then
popMailReceive$(1)



Print anzahl + " neue Nachrichten."
Print

sender$ =  popMailFrom$()
Print "Sendername: " + stringausstring(sender$,1,0)
Print "Senderadresse: " + stringausstring(sender$,2,0)
Print "SenderIP: " + popMailIP$()
Print "Datum: " + popMailDateDate$()
Print "Tag: " + popMailDateDay$()
Print "Zeit: " + popMailDateTime$()
Print
Print 
Print "Subject: " + popMailSubject$()
Print 

mailtext$ = popMailText$()

i = 1
Repeat 
	Print stringausstring$(mailtext$, i, 0)
	i = i + 1 
Until Len(stringausstring$(mailtext$, i, 0)) = 1 And stringausstring$(mailtext$, i, 0) = "0"


; Nach einem Mailabruf muss man sich anscheinend nochmal einloggen um wieder
; was machen zu knnen. Sehr mysteris...
;Print popAccountLogin$("pop3.web.de", "robscure", "biebenbabenbopp")
;Print popMailDelete$(1)
;Print popAccountLogout$()

;Print SaveMail$("SaveMail-mail.dat")


Else
Print "no new messages"
EndIf
Else
Print login$
EndIf
WaitKey()
End
;-----------------------------------------------------

;...................................................................


; SMTP-Mail-Sending ist sehr viel einfacher:

; mailtext$ = "Hallo, ich bin Zeile eins." + Chr$(0) + "Und ich Zeile zwei, wohee!" + Chr$(0) + Chr$(0) + "zeile drei mit doppellcke... welch innovation."


; Print smtpSendMail$(server$, to_name$, to_adress$, from_name$, from_adress$, subject$, mailtext$)

; Oft muss man sich erst per POP anmelden um mails verschicken zu knnen (SMTP after POP)

;----------------------------------------------------------------------------















; Liefert die Sendezeit zurck
Function popMailDateTime$()
 For i = 1 To Len(mailzeilen$(4))
		If Mid(mailzeilen$(4), i, 1) = ";" Then
      For ii = i+7 To Len(mailzeilen$(4))
       If Mid(mailzeilen$(4), ii, 1) = " " Then leer = leer + 1
       If leer = 4 Then Return Mid(mailzeilen$(4), i+19, ii-(i+19)) 
		  Next
		EndIf
	Next
End Function

;**********************************************************************
; Liefert das Sendedatum in Form 01 Feb 2002 zurck.
Function popMailDateDate$()
  For i = 1 To Len(mailzeilen$(4))
		If Mid(mailzeilen$(4), i, 1) = ";" Then
      For ii = i+7 To Len(mailzeilen$(4))
       If Mid(mailzeilen$(4), ii, 1) = " " Then leer = leer + 1
       If leer = 3 Then Return Mid(mailzeilen$(4), i+7, ii - (i+7)) 
		  Next
		EndIf
	Next
End Function

;**********************************************************************
; Liefert den Tag des sendens (als Kurzversion) zurck
Function popMailDateDay$()
	For i = 1 To Len(mailzeilen$(4))
		If Mid(mailzeilen$(4), i, 1) = ";" Then
      For ii = i+2 To i+5
				If Mid(mailzeilen$(4), ii, 1) = "," Then Return Mid(mailzeilen$(4), i+2, ii-(i+2))
		  Next
		EndIf
	Next	
End Function

;****************************************************************
; Gibt die IP-Adresse des Senders zurck
Function popMailIP$()
	For i = 1 To Len(mailzeilen$(1))
		If Mid(mailzeilen$(1), i, 1) = "[" Then
			For ii = i+1 To Len(mailzeilen$(1))
				If Mid(mailzeilen$(1), ii, 1) = "]" Then
					Return Mid(mailzeilen$(1), i+1, ii - (i+1))
				EndIf
			Next
		EndIf
	Next
End Function

;*****************************************************************
; Gibt die Betreffzeile der Mail zurck.
Function popMailSubject$()
	For i = 1 To mailzeilen_anzahl
		If Mid(mailzeilen$(i), 1, 8) = "Subject:" Then Return Mid(mailzeilen$(i), 10, Len(mailzeilen$(i)) - 9)
	Next
End Function

;*******************************************************************
; Gibt dein eigentlichen Mailtext in einem einzigen String zurck.
; Die Zeilen werden durch chr$(0) getrennt und knnen dann mit stringausstring()
; wieder extrahiert werden.
Function popMailText$()
	For i = 1 To mailzeilen_anzahl
		If mailzeilen$(i) = "" Then	
			For ii = i+1 To mailzeilen_anzahl-2
				If ii = mailzeilen_anzahl-2 Then
					message$ = message$ + mailzeilen$(ii)
				Else
					message$ = message$ + mailzeilen$(ii) + Chr$(0)
				EndIf
			Next
			Return message$
		EndIf
  Next
End Function

;**********************************************************************
; Gibt den Sender der Nachricht zurck.
; In der Form "Name" und "nickname@xxx.de"
Function popMailFrom$()
; Nicht am Anfang anfangen da das "From:" erst recht spt im Header kommt
For i = 1 To mailzeilen_anzahl
	If Mid(mailzeilen$(i), 1, 5) = "From:" Then
    ; Den String extrahieren in dem der Name und die Adresse steht
    For ii = 7 To Len(mailzeilen$(i))
      If Mid(mailzeilen$(i), ii, 1) = ">" Then
        from$ = Mid(mailzeilen$(i), 7, Len(mailzeilen$(i)) - 6)
        Exit
      EndIf
    Next
    For ii = 1 To Len(from$)
      If Mid(from$, ii, 1) = " " Then
        name$ = Mid(from$, 1, ii-1)
        email$ = Mid(from$, ii+2, Len(from$)- (ii+2))
        Return name$ + Chr$(0) + email$
      EndIf
    Next
  EndIf
Next
End Function

; *************************************************************************
; Empfngt eine Nachricht, gibt die ganze Nachricht in einem String zurck. Dieser muss dann
; mit der stringausstring-Function auseinandergenommen werden.
Function popMailReceive$(nummer)
mailzeilen_anzahl = 0
WriteLine com, "RETR " + nummer
i$ = ReadLine(com)
If Mid(i$, 1, 1) = "-" Then
  Return "-ERR no such mail"
Else
  Repeat
    mailzeilen_anzahl = mailzeilen_anzahl + 1
    WriteLine com, Chr$(28) ; Mit 'Enter" eine neue Zeile abrufen
    i$ = ReadLine(com)
    If Mid(i$, 1, 1) = "." And Len(i$) = 1 Then
      message$ = message$ + i$
    Else
      message$ = message$ + i$ + Chr$(0); Die ganze Nachricht, durch chr$(0) getrennt in einem String speichern.
    EndIf
  Until Mid(i$, 1, 1) = "." And Len(i$) = 1
  ; Das Mailzeilen-Feld mit der zeilenanzahl neu dimensionieren
  Dim mailzeilen$(mailzeilen_anzahl)  
  ; Die Nachricht durchgehn, die Zeilen extrahieren und in dem Feld speichern.
  For z = 1 To mailzeilen_anzahl
  mailzeilen$(z) = stringausstring$(message$, z, 0)
  Next 
EndIf 
End Function

;***************************************************************************
; Lscht die Mail mit der mailnummer. Existiert sie nciht, kommt eine Fehlermeldung zurck.
; Damit die Mail wirklich gelscht wird, muss man sich erst ausloggen.
Function popMailDelete$(mailnummer)
	WriteLine com, "DELE " + mailnummer ; Mail-Lsch-Kommando senden
	r$ = ReadLine(com) ; Rckgabe holen
	If Mid(r$, 1, 3) = "+OK" Then Return "+OK mail was deleted successful"
	If Mid(r$, 1, 4) = "-ERR" Then Return "-ERR mail could not be deleted"
  ; Bei mir kommt immer ein -ERR zurck, auch wenn die mail gelscht wurde... Einfach nochmal einloggen ohne vorher eine Mail abzurufen, dann kommt auch die richtige Meldung...

End Function

; *************************************************************************
; Gibt zurck wieviele Mails auf dem Server liegen und wie gro sie insgesamt sind.
Function popAccountStat$()
WriteLine com, "STAT"
i$ = ReadLine(com)
If Mid(i$, 1, 1) = "-" Then
  Return "-ERR no new messages"
Else
  For z = 5 To Len(i$)
    If Mid(i$, z, 1) = " " Then
      anzahl$ = Mid(i$, 5, z-5)
      groesse$ = Mid(i$, z+1, Len(i$))
      Return anzahl$ + "," + groesse$
    EndIf
  Next   
EndIf
End Function

; **************************************************************************
; Eine Verbindung zu einem Server aufbauen und sich anmelden.
; Liefert Error- oder Erfolgsmeldungen zurck.
Function popAccountLogin$(server$, user$, pass$)
com = OpenTCPStream(server$, 110)
If com = 0 Then
  Return "-ERR connection failed"
Else
  i$ = ReadLine(com) ; Die Begrung abfangen
  
  WriteLine com, "USER " + user$
  i$ = ReadLine(com)
  If Mid(i$, 1, 1) = "-" Then
    Return "-ERR no such user"  
  Else
    WriteLine com, "PASS " + pass$
    i$ = ReadLine(com)
    If Mid(i$, 1, 1) = "-" Then
      Return "-ERR password wrong"
    Else
      Return "+OK logged in   
    EndIf
  EndIf
EndIf
End Function

;*******************************************************************************
; Trennt die Verbindung mit dem Server. Erst hiernach werden z.B. Mails wirklich gelscht.
Function popAccountLogout$()
	WriteLine com, "QUIT" ; Verbindung trennen
	r$ = ReadLine(com) ; Rckgabe holen
	If Mid(r$, 1, 3) = "+OK" Then Return "+OK disconnected"
	If Mid(r$, 1, 4) = "-ERR" Then Return "-ERR not disconnected. waaah!"
End Function

;********************************************************************************
; Sendet eine Mail.
Function smtpSendMail$(server$, an_name$, an_adresse$, von_name$, von_adresse$, subject$, mailtext$)
	com = OpenTCPStream(server$ ,25)
	If com = 0 Then
		Return "-ERR smtp connection failed"
	Else
		s$ = ReadLine(com) ; Die Begrung abfangen
		WriteLine com, "HELO R-Mail"
  	s$ = ReadLine(com)
		If Mid(s$, 1, 3) <> "250" Then
		  Return "-ERR HELO failed"
		Else
		  WriteLine com, "MAIL FROM: " + von_adresse$
		  s$ = ReadLine(com)
  	  If Mid(s$, 1, 3) <> "250" Then
		    If Mid(s$, 1, 3) = "501" Then
		      Return "-ERR use POP-login first"
		    Else
		      Return "-ERR MAIL FROM failed"
        EndIf
		  Else
		    WriteLine com, "RCPT TO: " + an_adresse$
		    s$ = ReadLine(com)
		    If Mid(s$, 1, 3) <> "250" Then
		      Return "-ERR RCPT TO failed"
		    Else
		      WriteLine com, "DATA"
		      s$ = ReadLine(com)
		      If Mid(s$, 1, 3) <> "354" Then
		        Return "DATA failed"
		      Else
		        WriteLine com, "Date: " + CurrentDate$ ()
		        WriteLine com, "From: " + von_name$ + " <" + von_adresse$ + ">"
    		    WriteLine com, "To: " + an_name$ + " <" + an_adresse$ + ">"
        		WriteLine com, "Subject: " + subject$
        		WriteLine com, "X-Mailer: R-Mail"
		        i = 1
						Repeat 
							WriteLine com, stringausstring$(mailtext$, i, 0)
							i = i + 1 
						Until Len(stringausstring$(mailtext$, i, 0)) = 1 And stringausstring$(mailtext$, i, 0) = "0"
			      WriteLine com, ""
			      WriteLine com, "."
			      s$ = ReadLine(com)
			      If Mid(s$, 1, 3) <> "250" Then
		  	      Return "SendMail failed"
		    	  Else
		     	    WriteLine com, "QUIT" 
		    	      s$ = ReadLine(com)
		   	      If Mid(s$, 1, 3) <> "221" Then
		  	        Return "Mail delivery failed"   
		  	      Else
		  	        CloseTCPStream(com)
		  	        Return "+OK mail delivered"
		  	      EndIf 
	 	   	    EndIf  
		      EndIf  
		    EndIf    
		  EndIf       
		EndIf         
	EndIf	    
End Function

;**************************************************************************
; Speichert die gesamte Mail so wie sie angekommen ist in einer Datei.
Function SaveMail$(pfad$)
	datei = WriteFile(pfad$)
	If datei = 0 Then
		Return "-ERR mailfile could not be opened"
	Else
		For i = 1 To mailzeilen_anzahl
  		WriteLine datei, mailzeilen$(i)
		Next
		CloseFile datei
		Return "+OK mail saved"
	EndIf
End Function

;**************************************************************************
; Ldt eine Mail aus einer Datei.
Function LoadMail$(pfad$)
	datei = ReadFile(pfad$)
	If datei = 0 Then
		Return "-ERR mailfile could not be opened"
	Else
		Repeat
			mailzeilen_anzahl = mailzeilen_anzahl + 1
			i$ = ReadLine(datei)
			If Mid(i$, 1, 1) = "." And Len(i$) = 1 Then
				message$ = message$ + i$
			Else
				message$ = message$ + i$ + Chr$(0); Die ganze Nachricht, durch chr$(0) getrennt in einem String speichern.
			EndIf
		Until Mid(i$, 1, 1) = "." And Len(i$) = 1
		; Das Mailzeilen-Feld mit der zeilenanzahl neu dimensionieren
		Dim mailzeilen$(mailzeilen_anzahl)  
		; Die Nachricht durchgehn, die Zeilen extrahieren und in dem Feld speichern.
		For z = 1 To mailzeilen_anzahl
			mailzeilen$(z) = stringausstring$(message$, z, 0)
		Next 
		Return "+OK mail loaded"
	EndIf
End Function



















;----------------------------------------------------------------------------------

















; String-Funktionen




; Extrahiert aus einem String Zahlen, die durch ein Komma getrennt sind...
; Wichtig fr Functions die mehrere Werte zurckliefern. Man packt sie einfach in
; einen String, liefert den zurck und extrahiert die Zahlen dann wieder mit der Function hier.
 Function zahlausstring(zahlstring$, stelle)
	anzahl = 1 ; Anzahl der Zahlen
	letzteskomma = 1 ; Position des letzten Kommas
	For i = 1 To Len(zahlstring$)
		If Mid(zahlstring$, i, 1) = "," Or i = Len(zahlstring$) Then ; Wenn ein Trennzeichen erreicht ist
			If anzahl = stelle Then zahl = Mid(zahlstring$, letzteskomma, i) ; Zahl extrahieren
			letzteskomma = i+1 ; Solange die angegebene Stelle nciht erreicht ist, weitergehen
			anzahl = anzahl + 1
		EndIf
	Next
	Return zahl ; Zahl zurckgeben
End Function



; Extrahiert eine Teilstring aus einem groen String.
 Function stringausstring$(s$, stelle, trenncode)
	anzahl = 1 ; Anzahl der Textstellen 
	letzteskomma = 1 ; Position des letzten Kommas
	For i = 1 To Len(s$)
		If Asc(Mid(s$, i, 1)) = trenncode Or i = Len(s$) Then ; Wenn ein Trenncode erreicht ist
			If anzahl = stelle Then ; Wenn diese Stelle die angegebene ist...
				s2$ = Mid(s$, letzteskomma, i-letzteskomma) ; Text extrahieren
				If i = Len(s$) Then s2$ = Mid(s$, letzteskomma, i-(letzteskomma-1)) ; Wenn der Text der letzte im String ist, etwas anders extrahieren
			  If Len(Mid(s$,letzteskomma,i-letzteskomma)) = 1 Then s2$ = Chr$(0)
			EndIf
			letzteskomma = i+1 ; Weitergehen im String solange der Text noch nicht erreicht ist
			anzahl = anzahl + 1
		EndIf
	Next
	If stelle > (anzahl-1) Then Return "0"
	Return s2$
End Function



















;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
; Alter Debug-Code
; Einen String highlighten und an Position i den ASCII-Code ausgeben
;i = 400
;Repeat
;If KeyHit(203) Then i = i - 1
;If KeyHit(205) Then i = i + 1
;Cls
;Color 255,255,255
;Text 1, 16, Mid(nachricht$, 400, Len(nachricht$) - 400)
;Color 255,0,0
;Text (i-400)*8+1,16, Mid(nachricht$, i, 1)
;Text 1,32, Asc(Mid(nachricht$, i, 1))
;Flip
;Until KeyHit(1)


; Etwas in eine Datei schreiben...
;datei = WriteFile("mail.txt")
;WriteLine datei, nachricht$
;CloseFile datei