; Robs BB-Kurs 2
; Robert Gerlach 2.2002
;
; DotTunnel
; ----------------------------------------------
; Ein klassischer DotTunnel. Tunnel aus Punkten.




Global width = 640
Global height = 480
mode = 1
Global punkte_in_ring = 20
Global invert = 0 ; Schwarz auf wei oder wei auf schwarz.



Graphics width, height, 16, mode
SetBuffer BackBuffer()

If invert = 1 Then
ClsColor 255,255,255
Else
ClsColor 0,0,0
EndIf


Type com
	Field x#
	Field y#
  Field speed#
	Field winkel
End Type
Global dot.com 


Global x# = 320
Global y# = 240
Global zeit = MilliSecs()

Global m_winkel#

; Vorberechnete Sinus/Cosinus-Tabellen
Dim sinus#(360)
Dim cosinus#(360)

For i = 0 To 360
sinus#(i) = Sin(i)
cosinus#(i) = Cos(i)
Next





; Die Hauptschleife
Repeat
Cls

If MilliSecs() - zeit >= 100 Then
neuepunkte
zeit = MilliSecs()
EndIf


mittelpunktbewegen
punktebewegen


punktemalen

Flip
Until KeyHit(1)
End





; Den Ausgangspunkt der Einzelpunkte bewegen
Function mittelpunktbewegen()
m_winkel# = m_winkel# + .3
If m_winkel# >= 360 Then m_winkel# = 0

ym_winkel# = m_winkel# * 3
If ym_winkel# > 360 Then ym_winkel# = (m_winkel# * 3 - 360)
x# = (width / 2) - 200 * cosinus#(m_winkel#)
y# = y# + sinus#(ym_winkel#)


End Function







; Einen neuen Punktering erschaffen
Function neuepunkte()
	For i = 1 To punkte_in_ring
		dot.com = New com
		dot\x# = x#
		dot\y# = y#
		dot\winkel = (360 / punkte_in_ring) * i
	  dot\speed# = .08
	Next
End Function




; Die Punkte bewegen und am Rand des Screens lschen
Function punktebewegen()
For dot.com = Each com

dot\x# = xbewegen#(dot\x#, dot\winkel, dot\speed#)
dot\y# = ybewegen#(dot\y#, dot\winkel, dot\speed#)
dot\speed# = dot\speed# + .02
If dot\x# < 0 Or dot\x# > width Or dot\y# < 0 Or dot\y# > height Then Delete dot.com

Next

End Function


; Die Punkte zeichnen
Function punktemalen()
For dot.com = Each com
If invert = 0 Then
f = dot\speed# * 50
Else
f = 255 - (dot\speed# * 50)
EndIf 
Color f, f, f
Oval dot\x# - dot\speed#, dot\y# - dot\speed#, dot\speed# * 2, dot\speed# * 2
Next
End Function











; Bewegt einen Punkt auf der X-Achse mit der angegebenen Geschwindigkeit
Function xbewegen#(x#,winkel#,speed#)
x2# = x# + Cosinus#(winkel#)*speed#
Return x2#
End Function


; Das gleiche mit der Y-Achse.
Function ybewegen#(y#,winkel#,speed#)
y2# = y# + Sinus#(winkel#)*speed#
Return y2#
End Function














