; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; Fire
; ----------------------------------------------
; Zeichnet Feuer.
;
; Von: TheShadow
;      www.blitzbasic.de
;
; Sein Kommentar: Das Beispiel zeigt wie man Programme
;                 mit Tricks optimieren kann. In dem
;                 Beispiel werden die Daten in einem
;                 Dim-Feld gespeichert und berechnet.
;                 Danach wird nur jede zweite Zeile mit
;                 WritePixelFast eingezeichnet. Das so
;                 berechnete Bild wird mit GrabImage
;                 kopiert und um eine Zeile drunter mit
;                 DrawImage eingezeichnet. Da die schwarze
;                 Farbe im Image nicht eingezeichnet wird,
;                 erscheint das Feuer komplett! 









Graphics 640,480,16,1
buffer=BackBuffer()
SetBuffer buffer
Const firex=0
Const firey=380
Const firew=639
Const fireh=49
Dim fire(firew,fireh)
fireimg=CreateImage(firew+1,fireh*2+2)

Color 0,0,0
For x=0 To firew
  fire(x,fireh)=70
Next


While Not KeyHit(1)
  Rect firex,firey,firew+1,fireh*2+2,1
  LockBuffer buffer
  For y=0 To fireh-1
    For x=0 To firew
      fire(x,y)=fire(x,y+1)-2
      If fire(x,y)=>0 Then WritePixelFast firex+x,firey+y*2,fire(x,y)*$20100,buffer
    Next
  Next
  For x=0 To firew
    fire(x,fireh)=fire(x,fireh)+Rand(20)-10
  Next
  For x=1 To firew-1
    fire(x,fireh)=(fire(x-1,fireh)+fire(x,fireh)*3+fire(x+1,fireh))/5
  Next
  For x=0 To firew
    If fire(x,fireh)>127 Then fire(x,fireh)=127
    If fire(x,fireh)>0 Then WritePixelFast firex+x,firey+fireh*2,fire(x,fireh)*$20100,buffer
  Next
  UnlockBuffer buffer
  GrabImage fireimg,firex,firey,0
  DrawImage fireimg,firex,firey+1
  Flip
Wend


Dim fire(0,0)
FreeImage fireimg
EndGraphics
End