; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; Bezier
; ----------------------------------------------
; Zeichnet eine Bezierkurve die man mit der Maus steuern kann.
; Maussteuerung von mir.
;
; Original von: TheShadow
;               www.blitzbase.de
; 
;





Graphics 640, 480, 16, 2
SetBuffer BackBuffer()




;Beispiel
x1=50:  y1=150
x4=100: y4=50
x2=150: y2=250
x3=200: y3=150


Repeat
Cls

x3 = MouseX()
y3 = MouseY()

Bezier x1,y1, x4,y4, x2,y2, x3, y3
Oval x1-5,y1-5,10,10,0
Oval x4-5,y4-5,10,10,0
Oval x2-5,y2-5,10,10,0
Oval x3-5,y3-5,10,10,0
Text 0,0,"Bezier-Demo"


Flip
Until KeyHit(1)
End




;------------------------------------------------------------------
;Diese Grafikfunktion zeichnet eine Kurve, die nur an den Start-
;und Endpunkten berhrt wird.
;
;x1 = horizontale Startkoordinate
;y1 = vertikale   Startkoordinate
;x2 = horizontale Ablenkkoordinate 1
;y2 = vertikale   Ablenkkoordinate 1
;x3 = horizontale Ablenkkoordinate 2
;y3 = vertikale   Ablenkkoordinate 2
;x4 = horizontale Endkoordinate
;y4 = vertikale   Endkoordinate
;------------------------------------------------------------------
Function Bezier (x1, y1, x2, y2, x3, y3, x4, y4)
	cx# = 3 * (x2 - x1)
	bx# = 3 * (x3 - x2) - cx#
	ax# = x4 - x1 - cx# - bx#
	cy# = 3 * (y2 - y1)
	by# = 3 * (y3 - y2) - cy#
	ay# = y4 - y1 - cy# - by#
	For i# = 0 To 1.05 Step .05
		x = ((ax# * i# + bx#) * i# + cx#) * i# + x1
		y = ((ay# * i# + by#) * i# + cy#) * i# + y1
		If i#>0 Then Line oldx,oldy,x,y
		oldx=x
		oldy=y
	Next
End Function