; Robs BB-Kurs 2
; Robert Gerlach 1.2002
;
; Wegpunkte
; ----------------------------------------------
; Kleines Beispiel wie man einen Punkt an Wegpunkten entlang wandern lsst.
; Nur das Prinzip, nicht sehr elegant gelst. Wrde z.B. mit Types
; besser gehn... aber auch komplizierter.



Graphics 640, 480, 16, 2
SetBuffer BackBuffer()




; Die Wegpunkte aus Datei laden und in den Types speichern
datei = ReadFile("wegpunkte.txt")

zeile$ = ReadLine(datei) ; Die Anzahl der Wegpunkte einlesen
anzahl = zeile$


Dim x_punkt(anzahl)
Dim y_punkt(anzahl)

For i = 1 To anzahl
 zeile$ = ReadLine(datei) ; Zeile auslesen
 
 x_punkt(i) = zahlausstring(zeile$, 1) ; Erster Wert in der Zeile ist x
 y_punkt(i) = zahlausstring(zeile$, 2) ; Zweiter ist y



Next


CloseFile datei ; Datei wieder schlieen


; Spieler-Startkoordinaten
x# = x_punkt(1)
y# = y_punkt(1)





ziel = 2  ; Bei Punkt 1 wird angefangen, das nchste Ziel ist Punkt 2
winkel# = winkel_ausrechnen#(x#, y#, x_punkt(ziel), y_punkt(ziel)) 
; Einen Punkte die Wegpunkte abfahren lassen
Repeat
Cls





x# = xbewegen#(x#, winkel#, 1)
y# = ybewegen#(y#, winkel#, 1)

If Int(x#) = x_punkt(ziel) And Int(y#) = y_punkt(ziel) Then
ziel = ziel + 1
 
If ziel > anzahl Then ziel = 1
winkel# = winkel_ausrechnen#(x#, y#, x_punkt(ziel), y_punkt(ziel))
EndIf       


For i = 1 To anzahl
 Color 0,0,255
 Oval x_punkt(i) - 10, y_punkt(i) - 10, 20, 20, 0
 Color 255,255,255
 Text x_punkt(i) - 5, y_punkt(i) - 5, i
Next

Color 255,0,0
Oval x#-10, y#-10, 20, 20


Flip
Until KeyHit(1)
End





; Einen Punkt auf der x-Achse bewegen
Function xbewegen#(x#,winkel#,speed#)
x2# = x# + Cos(winkel#)*speed#
Return x2#
End Function

; Das gleiche mit y#.
Function ybewegen#(y#,winkel#,speed#)
y2# = y# + Sin(winkel#)*speed#
Return y2#
End Function


Function zahlausstring(zahlstring$, stelle)
anzahl = 1
letzteskomma = 1
For i = 1 To Len(zahlstring$)
If Mid(zahlstring$, i, 1) = "," Or i = Len(zahlstring$) Then
If anzahl = stelle Then zahl = Mid(zahlstring$, letzteskomma, i)
letzteskomma = i+1
anzahl = anzahl + 1
EndIf
Next
Return zahl
End Function



Function winkel_ausrechnen#(x1#,y1#,x2#,y2#)
xhypo# = x2# - x1#
yhypo# = y2# - y1#

; Sqr = Wurzel
abstand# = Abs(Sqr((xhypo# ^ 2) + (yhypo# ^2)))

winkel# = Abs(ACos(xhypo#/abstand#))

If Sgn(xhypo#) = -1 And Sgn(yhypo#) = -1 Then winkel# = 180 + (180 - winkel#)
If Sgn(xhypo#) = 1 And Sgn(yhypo#) = -1 Then winkel# = 270 + (90 - winkel#)

Return winkel#
End Function